#!/usr/bin/env python
# -*- coding:utf-8 -*-
from threading import Lock


class __RestConfig(object):

    __lock__ = Lock()
    __instance = None

    def __new__(cls, *args, **kwargs):
        with cls.__lock__:
            if not cls.__instance:
                cls.__instance = object.__new__(cls)
        return cls.__instance

    def __init__(self):
        self.__allow_redirection = True
        self.__check_status = False
        self.__only_body = True
        self.__encoding = "utf-8"

    @property
    def allow_redirection(self) -> bool:
        return self.__allow_redirection

    @allow_redirection.setter
    def allow_redirection(self, value: bool):
        if isinstance(value, bool):
            self.__allow_redirection = value

    @property
    def check_status(self) -> bool:
        return self.__check_status

    @check_status.setter
    def check_status(self, value: bool):
        if isinstance(value, bool):
            self.__check_status = value

    @property
    def only_body(self) -> bool:
        return self.__only_body

    @only_body.setter
    def only_body(self, value: bool):
        if isinstance(value, bool):
            self.__only_body = value

    @property
    def encoding(self) -> str:
        return self.__encoding

    @encoding.setter
    def encoding(self, value: str):
        if isinstance(value, str):
            self.__encoding = value
