#!/usr/bin/env python
# -*- coding:utf-8 -*-
from enum import Enum

from ..number import Integer
from ._calculator import _Converter


class StorageUnit(Enum):
    BIT = Integer(1)
    BYTE = Integer(BIT * 8)
    KB = Integer(BYTE * 1024)
    MB = Integer(KB * 1024)
    GB = Integer(MB * 1024)
    TB = Integer(GB * 1024)
    PB = Integer(TB * 1024)
    EB = Integer(PB * 1024)
    ZB = Integer(EB * 1024)
    YB = Integer(ZB * 1024)
    BB = Integer(YB * 1024)
    NB = Integer(BB * 1024)
    DB = Integer(NB * 1024)

    def of(self, num: int or float) -> '_Converter':
        converter = _Converter(num)
        setattr(converter, "_Converter__decimal", self.value)
        return converter


__all__ = [StorageUnit]
