#!/usr/bin/env python
# -*- coding:utf-8 -*-
from enum import Enum


class LogLevel(Enum):
    CRITICAL = 50
    FATAL = CRITICAL
    ERROR = 40
    WARNING = 30
    WARN = WARNING
    INFO = 20
    DEBUG = 10
    NOSET = 0

    @staticmethod
    def get_by_name(name) -> 'LogLevel':
        for e in LogLevel:
            if e.name == name:
                return e
        return LogLevel.INFO

