#!/usr/bin/env python
# -*- coding:utf-8 -*-
import enum
from typing import TypeVar

T = TypeVar("T")


def get_by_name(enum_: enum, name: str, default: enum = None) -> enum:
    """
    Gets the enumeration object by the enumeration name
    :param enum_: Enumerate classes
    :param name: Enumerates element name
    :param default: If the default value is not found
    :return:
    """
    for element in enum_:
        if element.name == name:
            return element
    return default


def get_by_value(enum_: enum, value: T, default: enum = None) -> enum:
    """
    Gets the enumeration object from the enumeration value
    :param enum_: Enumerate classes
    :param value: Enumerates element value
    :param default: If the default value is not found
    :return:
    """
    for element in enum_:
        if element.value == value:
            return element
    return default
